<template>
  <v-row justify="center"
    ><v-btn @click.stop="dialog = true">
      REGISTER
    </v-btn>
    <v-dialog v-model="dialog" max-width="50vw">
      <v-card>
        <v-card-title>
          <span class="headline">Register</span>
        </v-card-title>
        <v-card-text>
          <v-container>
            <v-row>
              <v-col cols="12">
                <v-text-field
                  v-model="username"
                  label="Username*"
                  required
                ></v-text-field>
              </v-col>
              <v-col cols="12">
                <v-text-field
                  v-model="email"
                  label="Email*"
                  required
                ></v-text-field>
              </v-col>
              <v-col cols="12">
                <v-text-field
                  v-model="password"
                  label="Password*"
                  type="password"
                  required
                ></v-text-field>
              </v-col>
            </v-row>
          </v-container>
          <small>*indicates required field</small>
          <br />
          <span v-if="error" class="error">{{ error }}</span>
        </v-card-text>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn text @click="dialog = false">Close</v-btn>
          <v-btn text @click="login">Save</v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </v-row>
</template>

<script>
import AuthenticationService from '@/services/AuthenticationService'
export default {
  data() {
    return {
      email: '',
      password: '',
      username: '',
      dialog: false,
      error: null
    }
  },
  methods: {
    async login() {
      try {
        const response = await AuthenticationService.register({
          email: this.email,
          password: this.password,
          user_name: this.username
        })
        this.$store.commit('store/setToken', response.data.token)
        this.$store.commit('store/setUser', response.data.user)
        this.dialog = false
      } catch (error) {
        this.error = error
      }
    }
  }
}
</script>

<style scoped>
.content {
  margin-left: var(--width-sidebar);
}
</style>
